// $Id:$   -*-c++-*-

#ifndef NTUPLE_H
#define NTUPLE_H

#ifndef __cplusplus


#define NTUPLE_BOOK() ntuple_book_event=1

#define NTUPLE_PTR(ID)						\
  static float* ntuple_array_##ID = 0;				\
  if (!ntuple_array_##ID) ntuple_array_##ID			\
    =  ntuple_pointer(ntuple_array, #ID);

#define NTUPLE_COPY_STATE(PTR)					\
  (PTR)[0]=x;  (PTR)[1]=y;  (PTR)[2]=z;				\
  (PTR)[3]=vx; (PTR)[4]=vy; (PTR)[5]=vz;			\
  (PTR)[6]=t;  (PTR)[7]=p

#define NTUPLE_STATE(ID)					\
  NTUPLE_PTR(x##ID);						\
  NTUPLE_COPY_STATE(ntuple_array_x##ID);

#define NTUPLE_FILL(ID,VAL)					\
  NTUPLE_PTR(ID);						\
  *ntuple_array_##ID = VAL

#define NTUPLE_VELOCITY(V)					\
  NTUPLE_FILL(V, sqrt(vx*vx+vy*vy+vz*vz))			\
  
#define NTUPLE_WAVELENGTH(L)					\
  NTUPLE_FILL(L, (2*PI/V2K)/sqrt(vx*vx+vy*vy+vz*vz))		\
  
#define NTUPLE_ENERGY(E)					\
  NTUPLE_FILL(E, VS2E*(vx*vx+vy*vy+vz*vz))			\


  float* ntuple_pointer();
  void 	 ntuple_clear();
  int    ntuple_open();
  void   ntuple_fill();
  void 	 ntuple_close();


#else

extern "C" {

  float*  ntuple_pointer(float* fill, char* var);
  void    ntuple_clear(int cnt, float* fill, float clear);
  int     ntuple_open(char* file, char* desc, char* fields);
  void    ntuple_fill(float* entries);
  void    ntuple_close();

}

#endif // __cplusplus

#endif // NTUPLE_H
